CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      MODULE USER_L
C******************************************************************
      INTEGER*4 METHOD,I,J
      REAL*8 HTC,Q,TF,GAM1,GY,RES,ARES
C******************************************************************
      END MODULE

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE USER
C*******************************************************************
      USE START_L
      USE USER_L
      IMPLICIT NONE
C******************************************************************
C ------------------------PROBLEM TWO------------------------------
C Two-dimensional steady-state heat conduction in a hollow cylinder
C------------------------------------------------------------------
C******************************************************************
      ENTRY GRID
      TITLE(4)=' TEMP '
      LSOLVE(4)=.TRUE.
      LAST=500
      TITLE(13)=' COND '  
      LPRINT(4)=.TRUE.
      LPRINT(13)=.TRUE.
      MODE=2
      XL=2.
      YL=1.
      R(1)=1.
      L1=27
      M1=27
      CALL UGRID
      RETURN
C
      ENTRY START
      METHOD=1
      DO 100 J=1,M1
      DO 101 I=1,L1
      T(I,J)=200.
      IF(I==1) T(I,J)=100.*(1.+Y(J))
  101 ENDDO
  100 ENDDO
      HTC=5.
      Q=50.
      TF=100.
      GAM1=1.
      RETURN
C
      ENTRY DENSE
      RETURN
C
      ENTRY BOUND
      DO 300 I=2,L1
      T(I,M1)=T(I,M2)
      T(I,1)=T(I,2)+Q*YDIF(2)/GAM1
  300 ENDDO
      GY=GAM1/XDIF(L1)
      DO 301 J=2,M1
      T(L1,J)=(HTC*TF+GY*T(L2,J))/(HTC+GY)
  301 ENDDO
      RETURN
C
      ENTRY OUTPUT
      IF(ITER==0) THEN
      PRINT 403,METHOD
      WRITE(8,403) METHOD
  403 FORMAT(1X,'  METHOD = ',I1)
      PRINT 401
      WRITE(8,401) 
  401 FORMAT(1X,'   ITER',11X,'T(4,5)',14X,'T(5,3)')
      ENDIF
      IF(ITER>0) PRINT 402,ITER,T(4,5),T(5,3)
      WRITE(8,402) ITER,T(4,5),T(5,3)
  402 FORMAT(1X,I6,2F20.5)
      IF(ITER==LAST) CALL PRINT
      RETURN
C
      ENTRY GAMSOR
      DO 500 J=1,M1
      DO 501 I=1,L1
      GAM(I,J)=GAM1
  501 ENDDO
  500 ENDDO
      DO 503 J=16,31
      DO 504 I=16,21
      GAM(I,J)=0.2*(1.+T(I,J)/100.)
  504 ENDDO
  503 ENDDO
      DO 510 J=2,M2
      DO 511 I=2,L2
      CON(I,J)=100.
      AP(I,J)=-0.5
  511 ENDDO
  510 ENDDO
      IF(METHOD==1) RETURN
      DO 520 I=2,L2
      GAM(I,M1)=0.
      GAM(I,1)=0.
      CON(I,2)=CON(I,2)+Q*R(1)/ARX(2)
  520 ENDDO
      RES=1./HTC+1./GY
      ARES=1./(RES*XCV(L2))
      DO 521 J=2,M2
      GAM(L1,J)=0.
      CON(L2,J)=CON(L2,J)+ARES*TF
      AP(L2,J)=AP(L2,J)-ARES
  521 ENDDO
      RETURN
      END
