CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      MODULE USER_L
C******************************************************************
       INTEGER*4 I,J
       REAL*8 AMU,DEN,COND,RHOCP,DPDZ,DTBDZ,ASUM,WSUM,TSUM,AR,WR,WBAR
     1        ,TB,DH,RE,FRE,ANU,TW,QW,THETA,DTDZ
C******************************************************************
      END MODULE
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
    
      
      SUBROUTINE USER
C*******************************************************************
      USE START_L
      USE USER_L
      IMPLICIT NONE

C******************************************************************
C       -------------------PROBLEM THREE--------------------
C       Fully developed laminar fluid flow and heat transfer
C       -----------------in a square duct-------------------
C******************************************************************

      ENTRY GRID
      TITLE(4)=' THETA '
      TITLE(5)=' W/WBAR '
      LSOLVE(5)=.TRUE.
      LPRINT(4)=.TRUE.
      LPRINT(5)=.TRUE.
      LAST=500
      XL=0.5
      YL=0.5
      L1=27
      M1=27
      CALL UGRID
      RETURN
C
      ENTRY START
      TW=0.
      DO 100 J=1,M1
      DO 100 I=1,L1
      W(I,J)=0.
      T(I,J)=1.
      T(I,M1)=TW
      T(L1,J)=TW
  100 CONTINUE
      AMU=1.
      DEN=1.
      COND=1.
      RHOCP=DEN*CPCON
      DPDZ=-100.
      DTBDZ=5.
      RETURN
C
      ENTRY DENSE
      RETURN
C
      ENTRY BOUND
      ASUM=0.
      WSUM=0.
      TSUM=0.
      DO 300 J=2,M2
      DO 301 I=2,L2
      AR=XCV(I)*YCV(J)
      WR=W(I,J)*AR
      ASUM=ASUM+AR
      WSUM=WSUM+WR
      TSUM=TSUM+WR*T(I,J)
  301 ENDDO
  300 ENDDO
      WBAR=WSUM/ASUM
      TB=TSUM/(WSUM+1.E-30)
      DH=4.*XL*YL/(XL+YL)
      RE=DEN*WBAR*DH/AMU
      FRE=(-DPDZ*DH/(0.5*DEN*WBAR**2+1.E-30))*RE
      QW=DTBDZ*RHOCP*WSUM/(XL+YL)
      ANU=QW*DH/(COND*(TW-TB)+1.E-30)
      IF(ITER>300) LSOLVE(5)=.FALSE.
      LSOLVE(4)=.TRUE.
      CONTINUE
      RETURN
C
      ENTRY OUTPUT
      IF(ITER==0) THEN
      PRINT 401
      WRITE(8,401)
  401 FORMAT('   ITER',12X,'F.RE',17X,'NU')
      ELSE
      PRINT 402,ITER,FRE,ANU
      WRITE(8,402) ITER,FRE,ANU
  402 FORMAT(I6,1P2E20.4)
      ENDIF
      IF(ITER/=LAST) RETURN
      DO 410 J=1,M1
      DO 411 I=1,L1
      W(I,J)=W(I,J)/WBAR
      T(I,J)=(T(I,J)-TW)/(TB-TW)
  411 ENDDO
  410 ENDDO

C    ΪԱֵ߽
      DO J=2,M2
           F(1,J,4)=F(2,J,4)
           F(1,J,5)=F(2,J,5)
      ENDDO
      DO I=1,L1
            F(I,1,4)=F(I,2,4)
            F(I,1,5)=F(I,2,5)              
      ENDDO

      CALL PRINT
      RETURN
C
      ENTRY GAMSOR
      DO 500 I=1,L1
      DO 500 J=1,M1
      GAM(I,J)=AMU
      IF(NF.EQ.4) GAM(I,J)=COND
      GAM(I,1)=0.
      GAM(1,J)=0.
  500 CONTINUE
      IF(NF.EQ.4)GO TO 511
      DO 510 J=2,M2
      DO 510 I=2,L2
      CON(I,J)=-DPDZ
  510 CONTINUE
      RETURN
  511 DO 520 J=2,M2
      DO 520 I=2,L2
      THETA=(T(I,J)-TW)/(TB-TW+1.E-30)
      DTDZ=THETA*DTBDZ
  520 CON(I,J)=-RHOCP*W(I,J)*DTDZ
      RETURN
      END
