CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      MODULE USER_L
C******************************************************************
       INTEGER*4 I,J
       REAL*8  PI,TW,AMU,DPDZ,COND,RHOCP,DTDZ,WSUM,ASUM,TSUM,AR,WBAR,WP
     1        ,DH,RE,FRE,TBULK,HTP,HTC,ANU
C******************************************************************
      END MODULE
      
      SUBROUTINE USER
C*******************************************************************
      USE START_L
      USE USER_L
      IMPLICIT NONE
C******************************************************************
C -------------------------PROBLEM FOUR----------------------------
C Fully developed laminar fluid flow and heat transfer in annular
C ------------duct with longitudinal fins on inner tube------------
C******************************************************************
C
      ENTRY GRID
      TITLE(4)=' THETA  '
      TITLE(5)=' W/WBAR '
      LSOLVE(5)=.TRUE.
      LPRINT(4)=.TRUE.
      LPRINT(5)=.TRUE.
      LAST=500
      NTIMES(4)=4
      NTIMES(5)=4
      MODE=3
      PI=3.14159
      THL=15.*PI/180.
      YL=1.
      R(1)=1.
      L1=27
      M1=27
      CALL UGRID
      RETURN
C
      ENTRY START
      TW=1.
      DO 100 J=1,M1
      DO 101 I=1,L1
      F(I,J,4)=TW
      F(I,J,5)=0.
  101 ENDDO
  100 ENDDO
      AMU=1.
      DPDZ=-2000.
      COND=1.
      RHOCP=1.
      DTDZ=100.
      RETURN
C
      ENTRY DENSE
      RETURN
C
      ENTRY BOUND
      WSUM=0.
      ASUM=0.
      TSUM=0.
      DO 300 J=2,M2
      DO 301 I=2,L2
      IF(I>6.OR.J>16) THEN
      AR=YCVR(J)*THCV(I)
      WSUM=WSUM+F(I,J,5)*AR
      TSUM=TSUM+AR*F(I,J,4)*F(I,J,5)
      ASUM=ASUM+AR
      ENDIF
  301 ENDDO
  300 ENDDO
      WBAR=WSUM/ASUM
      WP=(R(1)+R(M1))*THL+(1.+THCV(2))*(RMN(5)-R(1))
      DH=4.*ASUM/WP
      RE=RHOCON*WBAR*DH/AMU
      FRE=-2.*DPDZ*DH/(RHOCON*WBAR**2+1.E-30)*RE
      TBULK=TSUM/(WSUM+1.E-30)
      HTP=WP-R(M1)*THL
      HTC=RHOCP*WSUM*DTDZ/((TW-TBULK+1.E-30)*HTP)
      ANU=HTC*DH/COND
      IF(ITER<400)RETURN
      LSOLVE(4)=.TRUE.
      LSOLVE(5)=.FALSE.
      RETURN
C
      ENTRY OUTPUT
      IF(ITER==0) THEN
      PRINT 401
      WRITE(8,401)
  401 FORMAT('   ITER',12X,'F.RE',18X,'NU')
      ELSE
      PRINT 402,ITER,FRE,ANU
      WRITE(8,402) ITER,FRE,ANU
  402 FORMAT(I6,1P2E20.4)
      ENDIF
      IF(ITER/=LAST) RETURN
      DO 410 J=1,M1
      DO 411 I=1,L1
      F(I,J,5)=F(I,J,5)/WBAR
      F(I,J,4)=(F(I,J,4)-TW)/(TBULK-TW+1.E-30)
  411 ENDDO
  410 ENDDO

C    ΪԱֵ߽
      DO J=2,M2
           F(1,J,4)=F(2,J,4)
           F(L1,J,4)=F(L2,J,4)
           F(1,J,5)=F(2,J,5)
           F(L1,J,5)=F(L2,J,5)
      ENDDO
      DO I=1,L1
            F(I,M1,4)=F(I,M2,4) 
      ENDDO
      
      CALL PRINT
      RETURN
C
      ENTRY GAMSOR
      DO 500 J=1,M1
      DO 501 I=1,L1
      GAM(I,J)=AMU
      IF(NF==4) GAM(I,J)=COND
      GAM(1,J)=0.
      GAM(L1,J)=0.
      IF(NF==4) GAM(I,M1)=0.
      IF(J<=16) GAM(2:6,J)=1.E+10
      IF(NF==4.AND.J<=16) GAM(2:6,J)=10.*COND
  501 ENDDO
  500 ENDDO
      DO 510 J=2,M2
      DO 511 I=2,L2
      CON(I,J)=-DPDZ
      IF(NF==4) CON(I,J)=-DTDZ*F(I,J,5)*RHOCP
  511 ENDDO
  510 ENDDO
      RETURN
      END
