CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      MODULE USER_L
C******************************************************************
       INTEGER*4 I,J
       REAL*8 TIN,TW,VIN,VOUT,PR,AMU,COND,TREF,RHOREF,RHOT,FLOWIN,FL,
     1  FACTOR 
C******************************************************************
      END MODULE
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE USER
C*******************************************************************
      USE START_L
      USE USER_L
      IMPLICIT NONE    
C******************************************************************
C     -----------------------PROBLEM SIX-----------------------
C     Laminar fluid flow and heat transfer in a two-dimensional
C     ---------------------sudden expansion--------------------
C******************************************************************

C
      ENTRY GRID
      TITLE(1)='  VEL_U'
      TITLE(2)='  VEL_V'
      TITLE(3)=' STR_FN'
      TITLE(4)=' TEMP. '
      TITLE(11)='PRESSURE'
      TITLE(12)='DENSITY'
      RELAX(1)=0.8
      RELAX(2)=0.8
      LSOLVE(1)=.TRUE.
      LSOLVE(4)=.TRUE.
      LPRINT(1)=.TRUE.
      LPRINT(2)=.TRUE.
      LPRINT(3)=.TRUE.
      LPRINT(4)=.TRUE.
      LPRINT(11)=.TRUE.
      LPRINT(12)=.TRUE.
      LAST=2000
      XL=0.5
      YL=2.
      L1=2+5*5
      M1=2+10*5
      CALL UGRID
      RETURN
C
      ENTRY START
      TIN=500.
      TW=300.
      VIN=100.
      VOUT=VIN*XCV(L2)/X(L1)*TW/TIN
      DO 100 J=1,M1
      DO 101 I=1,L1
      U(I,J)=0.
      V(I,J)=VOUT
      V(I,2)=0.
      V(1,J)=0.
      T(I,J)=TW
  101 ENDDO
  100 ENDDO
      V(L2-4:L2,2)=VIN
      T(L2-4:L2,1)=TIN
      PR=0.7
      AMU=1.
      COND=AMU*CPCON/PR   ! ܶΪϵ
      TREF=300.
      RHOREF=1.
      RHOT=RHOREF*TREF
      RETURN
C
      ENTRY DENSE
      DO 200 J=1,M1
      DO 201 I=1,L1
      RHO(I,J)=RHOT/T(I,J)
  201 ENDDO
  200 ENDDO
      RETURN
C
      ENTRY BOUND
      IF(ITER==0) FLOWIN=RHO(L2,1)*V(L2,2)*XCV(L2)
      FL=0.
      DO 301 I=2,L2
      FL=FL+RHO(I,M1)*V(I,M2)*XCV(I)
  301 ENDDO
      FACTOR=FLOWIN/FL
      DO 302 I=2,L2
      V(I,M1)=V(I,M2)*FACTOR
      T(I,M1)=T(I,M2)
  302 ENDDO
      RETURN
C
      ENTRY OUTPUT
      IF(ITER==0) THEN
      PRINT 401
      WRITE(8,401)
  401 FORMAT('   ITER',7X,'SMAX',11X,'SSUM',10X,'V(4,7)',
     1 9X,'T(4,7)')
      ELSE
      PRINT 403,ITER,SMAX,SSUM,V(4,7),T(4,7)
      WRITE(8,403) ITER,SMAX,SSUM,V(4,7),T(4,7)
  403 FORMAT(I6,1P4E15.3)
      ENDIF
      IF(ITER==LAST) THEN
C    ΪԱֵ߽
      DO J=1,M1
      V(L1,J)=V(L2,J)
      T(L1,J)=T(L2,J)
      RHO(L1,J)=RHO(L2,J)
      ENDDO
      CALL PRINT
      ENDIF
      RETURN
C
      ENTRY GAMSOR
      DO 500 J=1,M1
      DO 501 I=1,L1
      GAM(I,J)=AMU
      IF(NF==4) GAM(I,J)=COND*RHO(I,J)
      IF(NF/=1) GAM(L1,J)=0.
      GAM(I,M1)=0.
  501 ENDDO
  500 ENDDO
      RETURN
      END
