CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      MODULE USER_L
C******************************************************************
       INTEGER*4 I,J
       REAL*8 GBR,DPDZ,PR,AMU,COND,FRE,WBAR,TM
C******************************************************************
      END MODULE
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE USER
C*******************************************************************
      USE START_L
      USE USER_L
      IMPLICIT NONE  
C******************************************************************
C    ---------------------PROBLEM SEVEN-------------------------
C    Complex fully developed laminar flow and heat transfer in a 
C    ------------------horizontal square duct-------------------
C******************************************************************
C
      ENTRY GRID
      TITLE(1)='  VEL_U'
      TITLE(2)='  VEL_V'
      TITLE(3)=' STR_FN' 
      TITLE(4)=' TEMP  ' 
      TITLE(5)=' W/WBAR'
      TITLE(11)='PRESSURE'
      RELAX(1)=0.8
      RELAX(2)=0.8
      LSOLVE(1)=.TRUE.
      LSOLVE(4)=.TRUE.
      LPRINT(1)=.TRUE.
      LPRINT(2)=.TRUE.
      LPRINT(3)=.TRUE.
      LPRINT(4)=.TRUE.
      LPRINT(5)=.TRUE.
      LPRINT(11)=.TRUE.
      LAST=500
      XL=1.0
      YL=1.0
      L1=27
      M1=27
      CALL UGRID
      RETURN
C
      ENTRY START
      GBR=1.E+4
      DPDZ=-3000.
      DO 100 J=1,M1
      DO 101 I=1,L1
      U(I,J)=0.
      V(I,J)=0.
      T(I,J)=0.
      T(L1,J)=1.
      F(I,J,5)=100.
      IF(I==1.OR.I==L1) F(I,J,5)=0.
      IF(J==1.OR.J==M1) F(I,J,5)=0.
  101 ENDDO
  100 ENDDO
      PR=0.7
      AMU=1.
      COND=AMU*CPCON/PR*RHOCON
      RETURN
C
      ENTRY DENSE
      RETURN
C
      ENTRY BOUND
      FRE=0.
      IF(ITER<300) RETURN
      IF(.NOT.LSOLVE(5)) THEN
      LSOLVE(1)=.FALSE.
      LSOLVE(5)=.TRUE.
      ENDIF
      WBAR=0.
      DO 302 J=2,M2
      DO 303 I=2,L2
      WBAR=WBAR+F(I,J,5)*XCV(I)*YCV(J)
  303 ENDDO
  302 ENDDO
      FRE=-DPDZ*2.*4.*(XL*YL)**3/(XL+YL)**2/(WBAR*AMU)
      RETURN
C
      ENTRY OUTPUT
      IF(ITER==0) THEN
      PRINT 401
      WRITE(8,401)
  401 FORMAT('   ITER',6X,'SMAX',8X,'SSUM',7X,'V(6,4)',
     1 6X,'T(2,6)',6X,'F.RE')
      ELSE
      PRINT 403,ITER,SMAX,SSUM,V(6,4),T(2,6),FRE
      WRITE(8,403) ITER,SMAX,SSUM,V(6,4),T(2,6),FRE
  403 FORMAT(I6,1P5E12.3)
      ENDIF
      IF(ITER/=LAST) RETURN
      DO 410 J=1,M1
      DO 411 I=1,L1
      F(I,J,5)=F(I,J,5)/WBAR
  411 ENDDO
  410 ENDDO

C    ΪԱֵ߽
      DO I=1,L1
      F(I,M1,4)=F(I,M2,4)
      F(I,1,4)=F(I,2,4)
      ENDDO

      CALL PRINT
      RETURN
C
      ENTRY GAMSOR
      DO 500 J=1,M1
      DO 501 I=1,L1
      GAM(I,J)=AMU
      IF(NF==4) THEN
      GAM(I,J)=COND
      GAM(I,1)=0.
      GAM(I,M1)=0.
      ENDIF
  501 ENDDO
  500 ENDDO
      DO 510 J=2,M2
      DO 511 I=2,L2
      IF(NF==2) THEN
      IF(J/=2) THEN
      TM=0.5*(T(I,J)+T(I,J-1))
      CON(I,J)=TM*GBR
      ENDIF
      ENDIF
      IF(NF==5) CON(I,J)=-DPDZ
  511 ENDDO
  510 ENDDO
      RETURN
      END
