CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      MODULE USER_L
C******************************************************************
       INTEGER*4 I,J
       REAL*8 OMEGA,UIN,AMU,FLOWIN,AR,ADD,FL,RSWM,RHOM,FLT
C******************************************************************
      END MODULE
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      SUBROUTINE USER
C*******************************************************************
      USE START_L
      USE USER_L
      IMPLICIT NONE  
C******************************************************************
C            --------------PROBLEM EIGHT----------------
C            Laminar impinging flow over a rotating disk
C            -------------------------------------------
C******************************************************************
C
      ENTRY GRID
      TITLE(1)=' VEL_U '
      TITLE(2)=' VEL_V '
      TITLE(3)=' STR_FN'
      TITLE(5)=' R.VTH '
      TITLE(11)='PRESSURE'
      RELAX(1)=0.8
      RELAX(2)=0.8
      LSOLVE(1)=.TRUE.
      LSOLVE(5)=.TRUE.
      LPRINT(1)=.TRUE.
      LPRINT(2)=.TRUE.
      LPRINT(3)=.TRUE.
      LPRINT(5)=.TRUE.
      LPRINT(11)=.TRUE.
      LAST=500
      MODE=2
      XL=0.5
      YL=0.5
      L1=27
      M1=27
      R(1)=0.
      CALL UGRID
      RETURN
C
      ENTRY START
      OMEGA=100.
      UIN=100.
      DO 100 J=1,M1
      DO 101 I=1,L1
      U(I,J)=0.
      V(I,J)=0.
      F(I,J,5)=0.
      F(L1,J,5)=R(J)**2*OMEGA
  101 ENDDO
  100 ENDDO
      U(2,2:6)=UIN
      AMU=1.
      RETURN
C
      ENTRY DENSE
      RETURN
C
      ENTRY BOUND
      IF(ITER.NE.0) THEN
      FLOWIN=0.
      DO J=2,6
      FLOWIN=FLOWIN+RHO(1,J)*U(2,J)*YCVR(2)
      ENDDO
      ENDIF
      FL=0.
      AR=0.
      DO 301 I=L2-9,L2
      FLT=R(M1)*XCV(I)*RHO(I,M1)
      AR=AR+FLT
      FL=FL+FLT*V(I,M2)
  301 ENDDO
      ADD=(FLOWIN-FL)/AR
      DO 302 I=L2-9,L2
      V(I,M1)=V(I,M2)+ADD
  302 ENDDO
       
       DO I=1,L1
       U(I,1)=U(I,2)
       ENDDO
      RETURN
C
      ENTRY OUTPUT
      IF(ITER==0) THEN
      PRINT 401
      WRITE(8,401) 
  401 FORMAT('   ITER',7X,'SMAX',11X,'SSUM',10X,'U(4,4)',
     1 9X,'V(4,4)')
      ELSE
      PRINT 403,ITER,SMAX,SSUM,U(4,4),V(4,4)
      WRITE(8,403) ITER,SMAX,SSUM,U(4,4),V(4,4)
  403 FORMAT(I6,1P4E15.4)
      ENDIF
      IF(ITER==LAST) CALL PRINT
      RETURN
C
      ENTRY GAMSOR
      IF(ITER==0) THEN
      DO 500 J=1,M1
      DO 501 I=1,L1
      GAM(I,J)=AMU
  501 ENDDO
  500 ENDDO
      GAM(L2-9:L2,M1)=0.
      ENDIF
      IF(NF==2) THEN
      DO 502 J=3,M2
      DO 503 I=2,L2
      RSWM=FY(J)*F(I,J,5)+FYM(J)*F(I,J-1,5)
      RHOM=FY(J)*RHO(I,J)+FYM(J)*RHO(I,J-1)
      CON(I,J)=RHOM*RSWM**2/RMN(J)**3
      AP(I,J)=-AMU/RMN(J)**2
  503 ENDDO
  502 ENDDO
      ENDIF
  510 IF(NF/=5) RETURN
      DO 512 J=2,M2
      DO 513 I=2,L2
      AR=2.*AMU/YCVR(J)
      CON(I,J)=AR*F(I,J-1,5)
      AP(I,J)=-AR
  513 ENDDO
  512 ENDDO
      RETURN
      END
