CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      MODULE USER_L

C******************************************************************
       INTEGER*4 I,J
       REAL*8 CMU,C1,C2,PRT,PRK,PRD,PRPRT,PFN,CMU4,AFL,VMIN,REL,
     1 AMT,ALOG,GAMP,GAMM,DUDX,DUDY,DVDX,DVDY,DISS,AMU,PR,
     2 FLOWIN,FL,FACTOR
C******************************************************************
      END MODULE
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      SUBROUTINE USER
C*******************************************************************
      USE START_L
      USE USER_L
      IMPLICIT NONE 
C******************************************************************
C    -----------------------PROBLEM TEN------------------------
C    Turbulent fluid flow and heat transfer in a parallel duct  
C    --------with stepwise inlet velocity distribution--------
C******************************************************************
      ENTRY GRID
      TITLE(1)=' VEL_U '
      TITLE(2)=' VEL_V '
      TITLE(3)=' STR_FN'
      TITLE(4)=' TEMP. ' 
      TITLE(5)='KIN_ENERGY'
      TITLE(6)='DISIPATION'
      TITLE(7)='TURB_VISC '
      TITLE(11)='PRESSURE'
      TITLE(12)='DENSITY'
      RELAX(1)=0.8
      RELAX(2)=0.6
      RELAX(5)=0.6
      RELAX(6)=0.6
      RELAX(13)=0.6
      LSOLVE(1)=.TRUE.
      LSOLVE(5)=.TRUE.
      LSOLVE(6)=.TRUE.
      LPRINT(1)=.TRUE.
      LPRINT(2)=.TRUE.
      LPRINT(3)=.TRUE.
      LPRINT(4)=.TRUE.
      LPRINT(5)=.TRUE.
      LPRINT(6)=.TRUE.
      LPRINT(7)=.TRUE.
      LPRINT(11)=.TRUE.
      LAST=4000
      XL=1.0
      YL=4.
      L1=2+5*2
      M1=2+7*2
      CALL UGRID
      RETURN
C
      ENTRY START
      DO 100 J=1,M1
      DO 101 I=1,L1
      U(I,J)=0.
      V(I,J)=10.
      V(1,J)=0.
      V(I,2)=10.
      IF(I>7) V(I,2)=100.
      T(I,J)=100.
      T(1,J)=0.
      IF(I>7) T(I,1)=400.
      AKE(I,J)=0.005*V(I,2)**2
      DIS(I,J)=0.1*AKE(I,J)**2
  101 ENDDO
  100 ENDDO
      AMU=1.E-6
      CMU=.09
      C1=1.44
      C2=1.92
      PRT=0.9
      PRK=1.
      PRD=1.3
      PR=0.7
      PRPRT=PR/PRT
      PFN=9.*(PRPRT-1.)/PRPRT**0.25
      CMU4=CMU**0.25
      RETURN
C
      ENTRY DENSE
      RETURN
C
      ENTRY BOUND
      IF(ITER==0) THEN
      FLOWIN=0.
      DO 310 I=2,L2
      FLOWIN=FLOWIN+RHO(I,1)*V(I,2)*XCV(I)
  310 ENDDO
      ELSE
      FL=0.
      AFL=0.
      VMIN=0.
      ENDIF
      DO 301 I=2,L2
      IF(V(I,M2)<0) VMIN=DMAX1(VMIN,-V(I,M2))
      AFL=AFL+RHO(I,M1)*XCV(I)
      FL=FL+RHO(I,M1)*V(I,M2)*XCV(I)
      FACTOR=FLOWIN/(FL+AFL*VMIN)
  301 ENDDO
      DO 302 I=2,L2
      V(I,M1)=(V(I,M2)+VMIN)*FACTOR
  302 ENDDO
      DO 303 J=2,M2
      AKE(L1,J)=AKE(L2,J)
      DIS(L1,J)=DIS(L2,J)
  303 ENDDO
      RETURN
C
      ENTRY OUTPUT
      IF(ITER==0) THEN
      PRINT 401
      WRITE(8,401)
  401 FORMAT('   ITER',6X,'SMAX',6X,'SSUM',5X,'V(6,6)',
     1 4X,'T(5,6)',4X,'KE(5,6)')
      ELSE
      PRINT 403,ITER,SMAX,SSUM,V(6,6),T(5,6),AKE(5,6)
      WRITE(8,403) ITER,SMAX,SSUM,V(6,6),T(5,6),AKE(5,6)
  403 FORMAT(I6,1P5E11.3)
      ENDIF
      IF(ITER>=3500) THEN
      LSOLVE(4)=.TRUE.
      LSOLVE(1)=.FALSE.
      LSOLVE(5)=.FALSE.
      LSOLVE(6)=.FALSE.
      ENDIF
      IF(ITER==LAST) THEN
C    ΪԱֵ߽      
      DO J=1,M1
      F(L1,J,2)=F(L2,J,2)
      F(L1,J,4)=F(L2,J,4)
      F(1,J,4)=F(2,J,4)
      ENDDO

      DO I=1,L1
      F(I,M1,4)=F(I,M2,4)
      ENDDO

      CALL PRINT
      ENDIF
      RETURN
C
      ENTRY GAMSOR
      IF(NF==3) RETURN
      IF(NF==1) THEN
      REL=1.-RELAX(NGAM)
      DO 500 J=1,M1
      DO 501 I=1,L1
      AMT=CMU*RHO(I,J)*AKE(I,J)**2/(DIS(I,J)+1.E-30)
      IF(ITER==0) AMUT(I,J)=AMT
      AMUT(I,J)=RELAX(NGAM)*AMT+REL*AMUT(I,J)
  501 ENDDO
  500 ENDDO
      FACTOR=1.
      ELSE
      FACTOR=1.
      ENDIF
      IF(NF==4) FACTOR=1./PRT
      IF(NF==5) FACTOR=1./PRK
      IF(NF==6) FACTOR=1./PRD
      DO 520 J=1,M1
      DO 521 I=1,L1
      GAM(I,J)=AMUT(I,J)*FACTOR
      IF(NF/=1) GAM(L1,J)=0.
      GAM(I,M1)=0.
  521 ENDDO
  520 ENDDO
      DO 530 J=2,M2
      SELECT CASE(NF)
      CASE(1,3,5,6)
      GAM(1,J)=0.
      CASE(2)
      XPLUS(J)=RHO(2,J)*SQRT(AKE(2,J))*CMU4*XDIF(2)/AMU
      GAM(1,J)=AMU
      IF(XPLUS(J)>11.5)GAM(1,J)=AMU*XPLUS(J)/(DLOG(9.*XPLUS(J))*2.5)
      CASE(4)
      GAM(1,J)=AMU*CPCON/PR
      IF(XPLUS(J)>11.5) GAM(1,J)=AMU/PRT*XPLUS(J)
     1 /(2.5*DLOG(9.*XPLUS(J))+PFN)
      ENDSELECT
  530 ENDDO
      IF(NF==1) THEN
      DO 590 J=2,M2
      DO 591 I=3,L2
      CON(I,J)=(GAM(I,J)*(U(I+1,J)-U(I,J))/XCV(I)
     1 -GAM(I-1,J)*(U(I,J)-U(I-1,J))/XCV(I-1))/XDIF(I)
      GAMP=GAM(I,J+1)*GAM(I-1,J+1)/(GAM(I,J+1)+GAM(I-1,J+1)+1.E-30)
      GAMP=GAMP+GAM(I,J)*GAM(I-1,J)/(GAM(I,J)+GAM(I-1,J)+1.E-30)
      GAMM=GAM(I,J-1)*GAM(I-1,J-1)/(GAM(I,J-1)+GAM(I-1,J-1)+1.E-30)
      GAMM=GAMM+GAM(I,J)*GAM(I-1,J)/(GAM(I,J)+GAM(I-1,J)+1.E-30)
      CON(I,J)=CON(I,J)+(GAMP*(V(I,J+1)-V(I-1,J+1))
     1 -GAMM*(V(I,J)-V(I-1,J)))/(YCV(J)*XDIF(I))
      AP(I,J)=0.
  591 ENDDO
  590 ENDDO
      RETURN
      ELSE IF(NF==2) THEN
      DO 594 J=3,M2
      DO 595 I=2,L2
      CON(I,J)=(GAM(I,J)*(V(I,J+1)-V(I,J))/YCV(J)-
     1 GAM(I,J-1)*(V(I,J)-V(I,J-1))/YCV(J-1))/(YDIF(J))
      GAMP=GAM(I+1,J)*GAM(I+1,J-1)/(GAM(I+1,J)+GAM(I+1,J-1)+1.E-30)
      GAMP=GAMP+GAM(I,J)*GAM(I,J-1)/(GAM(I,J)+GAM(I,J-1)+1.E-30)
      GAMM=GAM(I-1,J)*GAM(I-1,J-1)/(GAM(I-1,J)+GAM(I-1,J-1)+1.E-30)
      GAMM=GAMM+GAM(I,J)*GAM(I,J-1)/(GAM(I,J)+GAM(I,J-1)+1.E-30)
      CON(I,J)=CON(I,J)+(GAMP*(U(I+1,J)-U(I+1,J-1))
     1 -GAMM*(U(I,J)-U(I,J-1)))/(XCV(I)*YDIF(J))
      AP(I,J)=0.
  595 ENDDO
  594 ENDDO
      RETURN
      ENDIF
      IF(NF==4) THEN
      DO 596 J=2,M2
      DO 597 I=2,L2
      CON(I,J)=0.
      AP(I,J)=0.
  597 ENDDO
  596 ENDDO
      RETURN
      ELSE IF(NF==5) THEN
      DO 598 J=2,M2
      DO 599 I=2,L2
      DUDX=(U(I+1,J)-U(I,J))/XCV(I)
      DVDY=(V(I,J+1)-V(I,J))/YCV(J)
      IF(J==2) DUDY=(0.5*(U(I,J+1)-U(I,J))+0.5*(U(I+1,J+1)
     1 -U(I+1,J)))/YDIF(J+1)
      IF(J==M2) DUDY=(0.5*(U(I,J)-U(I,J-1))+0.5*(U(I+1,J)-U(I+1,J-1)))
     1 /YDIF(J)
      IF(J/=2.AND.J/=M2)DUDY=(0.5*(U(I,J+1)-U(I,J-1))+0.5*(U(I+1,J+1)-
     1U(I+1,J-1)))/(YDIF(J)+YDIF(J+1))
      IF(I==2) DVDX=(0.5*(V(I+1,J)-V(I,J))+0.5*(V(I+1,J+1)
     1 -V(I,J+1)))/XDIF(I+1)
      IF(I==L2) DVDX=(0.5*(V(I,J)-V(I-1,J))+0.5*(V(I,J+1)
     1 -V(I-1,J+1)))/XDIF(I)
      IF(I/=2.AND.I/=L2)DVDX=(0.5*(V(I+1,J)-V(I-1,J))+0.5*(V(I+1,J+1)
     1 -V(I-1,J+1)))/(XDIF(I)+XDIF(I+1))
      GEN(I,J)=2.*(DUDX**2+DVDY**2)+(DUDY+DVDX)**2
      CON(I,J)=GEN(I,J)*AMUT(I,J)
      AP(I,J)=-RHO(I,J)*DIS(I,J)/(AKE(I,J)+1.E-30)
  599 ENDDO
  598 ENDDO
      RETURN
      ENDIF
      DO 600 J=2,M2
      DO 601 I=2,L2
      CON(I,J)=C1*GEN(I,J)*CMU*RHO(I,J)*AKE(I,J)
      AP(I,J)=-C2*RHO(I,J)*DIS(I,J)/(AKE(I,J)+1.E-30)
  601 ENDDO
  600 ENDDO
      DO 602 J=2,M2
      DISS=CMU*AKE(2,J)**1.5/(0.4*CMU4*XDIF(2))
      CON(2,J)=1.E+30*DISS
      AP(2,J)=-1.E+30
  602 ENDDO
      RETURN
      END
